/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://java.net/hg/bluebill-mobile~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy.factsheet.impl.sound;

import javax.annotation.Nonnull;
import java.awt.event.ActionEvent;
import it.tidalwave.mobile.media.Media;
import it.tidalwave.bluebill.mobile.taxonomy.factsheet.ui.sound.DefaultTaxonSoundFactSheetViewController;
import it.tidalwave.bluebill.mobile.taxonomy.factsheet.ui.sound.TaxonSoundFactSheetView;
import lombok.extern.slf4j.Slf4j;
import static org.openide.util.NbBundle.*;
import static it.tidalwave.mobile.util.Downloadable.Downloadable;
import static it.tidalwave.mobile.util.Downloadable.Status.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Slf4j @SuppressWarnings("serial")
public class RefreshAction extends DownloadActionSupport
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public RefreshAction (final @Nonnull Media media,
                          final @Nonnull DefaultTaxonSoundFactSheetViewController controller,
                          final @Nonnull TaxonSoundFactSheetView view) 
      {
        super(media, controller, view);
        putValue(NAME, getMessage(_, "refreshMedia"));
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public void actionPerformed (final @Nonnull ActionEvent event)
      {
        log.info("actionPerformed({}) - media: {}", event, media);
        downloadMediaWithConfirmation(new Runnable()
          {
            @Override
            public void run() 
              {
                media.as(Downloadable).refresh();
              }
          });
      }      

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public boolean isEnabled() 
      {
        return isMediaInStatus(DOWNLOADED, OBSOLETE, BROKEN);
      }
  }